%define section         free

# To make the tarball:
#  export CVSROOT=:pserver:anonymous@cvs.forge.objectweb.org:/cvsroot/speedo
#  cvs login
#  cvs export -r SPEEDO_1_3_1 speedo

%define speedodir	%{_javadir}/speedo

Name:		speedo
Summary:	Open source implementation of the JDO (TM) 1.0.1 specification.
Version: 	1.3.1
Release:	1jpp_3rh
Epoch:		0
URL: 		http://speedo.objectweb.org/doc/
License: 	LGPL
Group: 		Development/Libraries/Java
Source0: 	%{name}-%{version}.tar.bz2
Patch0:		%{name}-%{version}-build.patch

BuildRequires:	jpackage-utils
BuildRequires:	ant
BuildRequires:	ant-nodeps
BuildRequires:	objectweb-anttask
BuildRequires:	apache-jdo-2.0-api >= 0-0.20050727.1jpp
BuildRequires:	asm >= 1.5.3
BuildRequires:	fractal >= 2.2
BuildRequires:	j2ee-connector >= 1.5
BuildRequires:	j2ee-management >= 1.0
BuildRequires:	jorm >= 2.6.4
BuildRequires:	jorm-rdb-adapter >= 3.0
BuildRequires:	jta >= 1.0.1
BuildRequires:	medor >= 1.6
BuildRequires:	medor-expression >= 1.6
BuildRequires:	monolog >= 2.0
BuildRequires:	mx4j >= 3.0.1
BuildRequires:	perseus-cache >= 1.5.2
BuildRequires:	perseus-concurrency >= 1.5.1
BuildRequires:	perseus-dependency >= 1.4
BuildRequires:	perseus-persistence >= 1.5.0
BuildRequires:	perseus-pool >= 1.4.3
BuildRequires:	velocity >= 1.4
Requires:		asm >= 1.5.3
Requires:		apache-jdo-2.0-api >= 0-0.20050727.1jpp
Requires:		fractal >= 2.2
Requires:		j2ee-connector >= 1.5
Requires:		j2ee-management >= 1.0
Requires:		jorm >= 2.6.4
Requires:		jorm-rdb-adapter >= 3.0
Requires:		jta >= 1.0.1
Requires:		medor >= 1.6
Requires:		medor-expression >= 1.6
Requires:		monolog >= 2.0
Requires:		mx4j >= 3.0.1
Requires:		perseus-cache >= 1.5.2
Requires:		perseus-concurrency >= 1.5.1
Requires:		perseus-dependency >= 1.4
Requires:		perseus-persistence >= 1.5.0
Requires:		perseus-pool >= 1.4.3
Requires:		velocity >= 1.4
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:		noarch

%description
Speedo is an open source implementation of the JDO (TM) 1.0.1 
specification.

%package client
Group:          Development/Libraries
Summary:        Speedo client

%description client
Speedo client classes.

%package for-jonas
Group:          Development/Libraries
Summary:        Speedo JOnAS classes

%description for-jonas
Speedo classes for JOnAS.

%package weblogic
Group:          Development/Libraries
Summary:        Speedo Weblogic classes

%description weblogic
Speedo classes for Weblogic.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}

#  find speedo -name '*.jar' | grep -v speedo/externals/jdo2.jar | xargs rm

%patch0 -p0

find . -name '*.?ar' | xargs rm

build-jar-repository externals \
	apache-jdo-2.0-api \
	asm/asm \
	asm/asm-attrs \
	fractal/fractal \
	fractal/fractal-adl \
	fractal/fractal-jmx \
	j2ee-connector \
	j2ee-management \
	jorm/ow_jorm \
	jorm/ow_jorm_runtime \
	jorm/ow_jorm_rdb_adapter \
	jta \
	medor/ow_medor_exp \
	medor/ow_medor \
	monolog/ow_monolog \
	monolog/ow_util_io \
	mx4j/mx4j \
	mx4j/mx4j-tools \
	perseus/ow_perseus_cache \
	perseus/ow_perseus_concurrency \
	perseus/ow_perseus_dependency \
	perseus/ow_perseus_persistence \
	perseus/ow_perseus_pool \
	velocity

# The wizard is not longer used, and will be 
# removed in future versions of speedo.
rm -rf src/org/objectweb/speedo/wizard

# Fix a line in the build file so that it works with [asm][asm], as created 
# by build-jar-repository.
sed -i -e 's:<include name="asm\*"/>:<include name="*asm*"/>:g' build.xml

%build
export OPT_JAR_LIST="ant/ant-nodeps objectweb-anttask"
ant rar jdoc

%install
rm -rf $RPM_BUILD_ROOT

# main package
install -d -m 755 $RPM_BUILD_ROOT%{speedodir}
install -m 644 output/dist/speedo.jar \
    $RPM_BUILD_ROOT%{speedodir}/speedo-%{version}.jar
ln -s speedo-%{version}.jar \
    $RPM_BUILD_ROOT%{speedodir}/speedo.jar

install -m 644 output/dist/speedo_ra.rar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_ra-%{version}.rar
ln -s speedo_ra-%{version}.rar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_ra.rar

# speedo-client
install -m 644 output/dist/speedo_client.jar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_client-%{version}.jar
ln -s speedo_client-%{version}.jar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_client.jar

# speedo-for-jonas
install -m 644 output/dist/speedo_for_jonas_ra.jar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_for_jonas_ra-%{version}.jar
ln -s speedo_for_jonas_ra-%{version}.jar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_for_jonas_ra.jar

install -d -m 755 $RPM_BUILD_ROOT%{speedodir}/rars
install -m 644 output/dist/speedo_for_jonas_ra.rar \
    $RPM_BUILD_ROOT%{speedodir}/rars/speedo_for_jonas_ra-%{version}.rar
ln -s speedo_for_jonas_ra-%{version}.rar \
    $RPM_BUILD_ROOT%{speedodir}/rars/speedo_for_jonas_ra.rar

# speedo-weblogic
install -m 644 output/dist/speedo_for_weblogic_ra.rar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_for_weblogic_ra-%{version}.rar
ln -s speedo_for_weblogic_ra-%{version}.rar \
    $RPM_BUILD_ROOT%{speedodir}/speedo_for_weblogic_ra.rar

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/dist/doc/jdoc/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%dir %{speedodir}
%{speedodir}/speedo-%{version}.jar
%{speedodir}/speedo.jar
%{speedodir}/speedo_ra-%{version}.rar
%{speedodir}/speedo_ra.rar

%files client
%defattr(0644,root,root,0755)
%dir %{speedodir}
%{speedodir}/speedo_client-%{version}.jar
%{speedodir}/speedo_client.jar

%files for-jonas
%defattr(0644,root,root,0755)
%dir %{speedodir}
%dir %{speedodir}/rars
%{speedodir}/*jonas*
%{speedodir}/rars/*jonas*

%files weblogic
%defattr(0644,root,root,0755)
%dir %{speedodir}
%{speedodir}/*weblogic*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Tue Aug 02 2005 Fernando Nasser <fnasser@redhat.com> 0:1.3.1-1jpp_3rh
- Change subpackage name and directory used to match joram handling of RAR

* Fri Jul 29 2005 Deepak Bhole <dbhole@redhat.com> 0:1.3.1-1jpp_2rh
- Remove jdo2.jar from source list.
- Have rpm delete jars -- this way the source tarball is pristine.

* Wed Jul 27 2005 Deepak Bhole <dbhole@redhat.com> 0:1.3.1-1jpp_1rh
- Upgrade version.
- Add patch to preserve when duplicate jorm classes are found

* Fri Jul 22 2005 Deepak Bhole <dbhole@redhat.com> 0:1.3.0-1jpp_3rh
- Changed build command to build client and rars as well.
- Split into sub-packages.

* Fri Jul 22 2005 Deepak Bhole <dbhole@redhat.com> 0:1.3.0-1jpp_2rh
- Bumped release to build in new branch.

* Fri Jul 22 2005 Deepak Bhole <dbhole@redhat.com> 0:1.3.0-1jpp_1rh
- Initial build.
